# PackagingJS

> ES4 style packaging, namespacing, and dependency implementation.

## Install

```sh
$ npm install --save-dev packagingjs
```

## Usage

### Via Node API

```javascript
var packagingjs = require('packagingjs');
var output = packagingjs('BaseClass', options);
```

### Arguments

#### BaseClass

The first argument takes a string in namespaced format to the class intended as your base class for the file build. So 'my.namespace.MainClass' would mean the file 'my/namespace/MainClass.js' in one of the roots you define in the options.

#### options.roots [default=['./']]

An array of strings of locations to look for PackagingJS style files when using imports, includes, and for base classes.

#### options.autorun [default='static']

Allows you to control how the base class is automatically started. The options are 'none' (which will not attempt to run any class at all), 'instance' (which will create a new instance of the base class automatically on start), and 'static' (which will call a static function '.main()' on the base class on start).

#### options.strict [default=false]

Boolean value for whether to make the entire output strict mode. Even when false you can still use strict mode in individual functions. This only allows you to automatically strict mode the entire file.

#### options.windows [default=false]

Boolean value that allows you to specify to use windows style CRLF line breaks in the output.

#### options.global [default='window']

A string value representing the global object for the environment your code is intended for. For browsers that is 'window', so that is the default.

### The PackagingJS Format

PackagingJS is currently in alpha testing and should not be used yet. This will tell you how to use it once it is meant for public use.
